/*
 Copyright 2002, 2003 Alexandre Gil
                                                                                
 This file is part of mwu-extractor.
                                                                                
 mwu-extractor is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
                                                                                
 mwu-extractor is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
                                                                                
 You should have received a copy of the GNU General Public License
 along with mwu-extractor; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// Nome: TCorpus.h
// Objectivo: Interface da abstracao para ficheiros do Corpus
//            Recebe um Corpus (conjunto de ficheiros de texto) na forma duma directoria e dum
//            ficheiro contendo a lista de ficheiros do Corpus.
// Autor: Alexandre Gil
// Data: 16 Mar 2002


#ifndef _H_TCorpus
#define _H_TCorpus

#include <fstream>
#include <iostream>

const int MAXFILES = 1000;
const int MAXFILENAME = 1000;

class TCorpus
{
	private:
		char * corpusName;
		struct {
			char * name;
		} file[MAXFILES];
		std::ifstream fp;
		int numFiles;
		bool erro;
		int currentFile;
		unsigned char current;
	private:
		virtual void ReadFileName(std::ifstream& fList, char * n, int max);
		void OpenCurrentFile();
		const char * ExtractName(const char * fullPathName) const;
	public:
	  TCorpus();
	  explicit TCorpus(const char * corpusName);
	  virtual ~TCorpus();
	  virtual bool Erro() const;
	  virtual bool AtEOF() const;
		virtual unsigned char Current() const;
		virtual void NextChar();
		virtual int NumOfFiles() const;
		virtual void NextFile();
		virtual bool AtEndOfCorpus() const;
		virtual const char * FileName() const;
		virtual const char * CorpusName() const;
};


#endif
