/*
 Copyright 2002, 2003 Alexandre Gil
                                                                                
 This file is part of mwu-extractor.
                                                                                
 mwu-extractor is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
                                                                                
 mwu-extractor is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
                                                                                
 You should have received a copy of the GNU General Public License
 along with mwu-extractor; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// Nome: TSTree.h
// Objectivo: Interface da abstracao para a classe TSTree
//            Arvore ternaria de strings
// 						Baseado no codigo de Jon Bentley & Bob Sergerwick
//            - Dr. Dobb's Journal April 1998
//						- Fast Algorithms for Sorting and Searching Strings, Jan 1997
//            
// Autor: Alexandre Gil
// Data: 17 Mar 2002


#ifndef _H_TSTree
#define _H_TSTree

#include <iostream>

#include "MyUtils.h"

template<class T>
struct TNode
{
	char splitchar;
	TNode* lokid;
	TNode* eqkid;
	TNode* hikid;
	T value;
};

template<class T>
class TSTree
{
	private:
		TNode<T>* root[256];
		T count;
	private:
		virtual void WriteNode(std::ostream& output, const char * prefix, const TNode<T>* node) const;
		virtual void DeleteNode(const TNode<T>* node);
		virtual TNode<T>* _Insert(const char * s, TNode<T>* node, int& v);
	public:
	  TSTree(const T count);
	  virtual ~TSTree();
		virtual T Insert(const char * s);
		virtual void Write(std::ostream& output = std::cout);
		virtual T Count() const;
};
	
#endif
